/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.remote;

import android.app.Activity;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.IBinder;
/**
 * @aPackage :      net.micode.notes.gtask.remote
 * @aClassName:     GTaskSyncService
 * @Description:
 * 该类继承了Service父类，Service是在一段不定的时间运行在后台，不和用户交互的应用组件
 * 作用：
 * GTask同步服务，用于提供同步服务（开始、取消同步)，发送广播
 * @aAuthor:        Li Qiushi
 * @createdate:     12/24/2023 20:15 PM
 */
public class GTaskSyncService extends Service {
    public final static String ACTION_STRING_NAME = "sync_action_type";

    public final static int ACTION_START_SYNC = 0;

    public final static int ACTION_CANCEL_SYNC = 1;

    public final static int ACTION_INVALID = 2;

    public final static String GTASK_SERVICE_BROADCAST_NAME = "net.micode.notes.gtask.remote.gtask_sync_service";

    public final static String GTASK_SERVICE_BROADCAST_IS_SYNCING = "isSyncing";

    public final static String GTASK_SERVICE_BROADCAST_PROGRESS_MSG = "progressMsg";

    private static GTaskASyncTask mSyncTask = null;

    private static String mSyncProgress = "";

    /**
     *功能：用于自动一个同步任务
     */
    private void startSync() {
        /*
        如果mSyncTask为null，则创建一个新的GTaskASyncTask对象，并将其赋值给mSyncTask
        这个新对象的构造函数接受两个参数：当前对象（this）和一个Lambda表达式
         */
        if (mSyncTask == null) {
            mSyncTask = new GTaskASyncTask(this, () -> {
                mSyncTask = null;
                sendBroadcast("");
                stopSelf();
            });
            sendBroadcast("");
            mSyncTask.execute();
        }
    }

    /**
     * 功能：取消同步任务，以避免不必要的资源占用和潜在的错误
     */
    private void cancelSync() {
        if (mSyncTask != null) {
            mSyncTask.cancelSync();
        }
    }

    @Override
    public void onCreate() {
        mSyncTask = null;
    }

    /**
     * 功能：
     * 用于处理启动服务时的命令
     * @param intent
     * @param flags
     * @param startId
     * @return int
     */
    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        Bundle bundle = intent.getExtras();
        if (bundle != null && bundle.containsKey(ACTION_STRING_NAME)) {
            switch (bundle.getInt(ACTION_STRING_NAME, ACTION_INVALID)) {
                //两种情况，开始同步或者取消同步
                case ACTION_START_SYNC:
                    startSync();
                    break;
                case ACTION_CANCEL_SYNC:
                    cancelSync();
                    break;
                default:
                    break;
            }
            return START_STICKY;
        }
        return super.onStartCommand(intent, flags, startId);
    }

    /**
     * 功能：用于处理低内存情况，当系统内存不足时，该方法会被调用
     */
    @Override
    public void onLowMemory() {
        if (mSyncTask != null) {
            mSyncTask.cancelSync();
        }
    }

    public IBinder onBind(Intent intent) {
        return null;
    }

    /**
     * 功能：发送一个广播消息，通知其他组件或服务有关同步任务的状态和进度信息
     * @param msg
     */
    public void sendBroadcast(String msg) {
        mSyncProgress = msg;
        Intent intent = new Intent(GTASK_SERVICE_BROADCAST_NAME);
        intent.putExtra(GTASK_SERVICE_BROADCAST_IS_SYNCING, mSyncTask != null);
        intent.putExtra(GTASK_SERVICE_BROADCAST_PROGRESS_MSG, msg);
        sendBroadcast(intent);//将intent对象发送出去，以便其他组件或服务可以接收到这个广播消息并进行相应的处理
    }

    /**
     * 功能：启动一个名为GTaskSyncService的服务来进行同步操作
     * @param activity
     */
    public static void startSync(Activity activity) {
        GTaskManager.getInstance().setActivityContext(activity);
        Intent intent = new Intent(activity, GTaskSyncService.class);
        intent.putExtra(GTaskSyncService.ACTION_STRING_NAME, GTaskSyncService.ACTION_START_SYNC);
        activity.startService(intent);//启动GTaskSyncService服务，之后服务就会开始执行同步操作
    }

    /**
     * 功能：取消正在进行的同步操作
     * @param context
     */
    public static void cancelSync(Context context) {
        Intent intent = new Intent(context, GTaskSyncService.class);
        intent.putExtra(GTaskSyncService.ACTION_STRING_NAME, GTaskSyncService.ACTION_CANCEL_SYNC);//向Intent对象添加额外的数据
        context.startService(intent);
    }

    public static boolean isSyncing() {
        return mSyncTask != null;
    }

    public static String getProgressString() {
        return mSyncProgress;
    }
}
